=== debian/changelog ===
clfft (2.12.2-7) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtest to work with CMake 4

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Sep 2025 22:27:16 +0200

clfft (2.12.2-6) unstable; urgency=medium

  * Team upload.
  * Bump CMake policy version (Closes: #1112789)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 22:29:57 +0200

clfft (2.12.2-5) unstable; urgency=medium

  * Team upload.
  * No longer call upstream build system install for --arch-all

 -- tony mancill <tmancill@debian.org>  Thu, 28 Sep 2023 07:39:01 -0700

clfft (2.12.2-4) unstable; urgency=medium

  * Team upload

  [ Jonathan Bergh ]
  * Apply reproducibility patch (Closes: #1003375)

  [ tony mancill ]
  * Update doc-base for actually install directory (libclfft-dev)
  * Set Rules-Requires-Root: no in debian/control
  * Use debhelper-compat 13
  * Bump Standards-Version to 4.6.2 (no changes)

 -- tony mancill <tmancill@debian.org>  Thu, 28 Sep 2023 06:10:19 -0700

clfft (2.12.2-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -fpermissive to workaround FTBFS with gcc 11.
    (Closes: #997197)

 -- Adrian Bunk <bunk@debian.org>  Thu, 06 Jan 2022 14:09:04 +0200

clfft (2.12.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/tests/build-examples: Fix path of examples after debhelper compat
    bump (Closes: #978002)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 10 Jan 2021 20:36:30 +0100

clfft (2.12.2-3) unstable; urgency=medium

  [ Anton Gladky ]
  * Team upload.
  * [c5c7aac] Add .gitlab-ci.yml
  * [58d881f] Update watch file format version to 4.
  * [fa9a95f] Bump debhelper from deprecated 9 to 12.
  * [fbede47] Set debhelper-compat version in Build-Depends.
  * [fc3f0e6] Set field Upstream-Contact in debian/copyright.
  * [b3eee1b] Set upstream metadata fields: Repository.
  * [2a7b81f] Update Vcs-* headers from URL redirect.
  * [d60c190] Use canonical URL in Vcs-Git.
  * [360f610] Drop unnecessary dh arguments: --parallel
  * [4c183bb] Remove obsolete fields Contact, Name from debian/upstream/metadata
  * [6999aaf] Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.
  * [085b994] Set Standards-Version 4.5.0. No changes

  [ Chris Lamb ]
  * [edf7325] Make the build reproducible. (Closes: #891075)

 -- Anton Gladky <gladk@debian.org>  Tue, 08 Dec 2020 20:41:18 +0100

clfft (2.12.2-2) UNRELEASED; urgency=medium

  * Remove unnecessary 'Testsuite: autopkgtest' header.
  * Trim trailing whitespace.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 20 Oct 2018 13:41:22 +0000

clfft (2.12.2-1) unstable; urgency=medium

  * New upstream release.
  * Update patch queue.
    - Refresh disable-multilib-cflags.patch.
    - Drop obsolete use-boost-dynamic-libs.patch.
  * Use Boost dynamic libraries via CMake options.
  * Rename package libclfft-bin to clfft-client.
  * Update description of binary packages.
  * Add missing Multi-Arch field for -dev and -doc.
  * Disable build of examples.
  * Minor enhancements to rules file.
    - Clear superfluous comments.
    - Wrap, sort and format.
  * Use HTTPS for Format field in copyright file.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 01 Sep 2016 13:29:32 +0100
