=== debian/control ===
Source: clfft
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
           Jerome Kieffer <jerome.kieffer@esrf.fr>,
           Jonathan Bergh <bergh.jonathan@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/clfft
Vcs-Git: https://salsa.debian.org/science-team/clfft.git
Homepage: https://github.com/clMathLibraries/clFFT
Rules-Requires-Root: no

Package: libclfft2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL FFT library
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the shared library.

Package: libclfft-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libclfft2 (= ${binary:Version}),
         ocl-icd-opencl-dev | opencl-dev
Suggests: libclfft-doc
Description: development files for clFFT
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the development files.

Package: libclfft-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: documentation for clFFT
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the documentation.

Package: clfft-client
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclfft2 (= ${binary:Version})
Breaks: libclfft-bin (<< 2.12.2-1)
Provides: libclfft-bin
Replaces: libclfft-bin (<< 2.12.2-1)
Description: client program for clFFT
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the client program.
