=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -fpermissive
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILD_OPTIONS = \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.10 \
	-DBoost_USE_STATIC_LIBS=OFF \
	-DBUILD_CLIENT=ON \
	-DBUILD_EXAMPLES=OFF \
	-DBUILD_LOADLIBRARIES=OFF \
	-DBUILD_RUNTIME=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TEST=OFF \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DSUFFIX_LIB="/$(DEB_TARGET_MULTIARCH)"

%:
	dh $@ --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build-indep:
	cd docs && doxygen clFFT.doxy

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

override_dh_auto_install-indep:
	# nothing to do here
	#
	# dh-compat 13 invokes this target, which invokes cmake install resulting
	# in a build failure when building with "--arch-all --no-arch-any"
	# Documentation is installed via other targets anyway.
