=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libclfft-dev,
         libclfft-doc
Restrictions: allow-stderr
