=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/clFFT-$1\.tar\.gz/ https://github.com/clMathLibraries/clFFT/tags .*/v?(\d\S*)\.tar\.gz
